<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.jbase;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.DataInput;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.DataOutput;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.EOFException;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.File;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.io.FileNotFoundException;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.io.IOException;<a name="line.41"></a>
<FONT color="green">042</FONT>    import java.util.HashMap;<a name="line.42"></a>
<FONT color="green">043</FONT>    import java.util.concurrent.atomic.AtomicReferenceArray;<a name="line.43"></a>
<FONT color="green">044</FONT>    import java.util.concurrent.locks.ReadWriteLock;<a name="line.44"></a>
<FONT color="green">045</FONT>    import java.util.concurrent.locks.ReentrantReadWriteLock;<a name="line.45"></a>
<FONT color="green">046</FONT>    <a name="line.46"></a>
<FONT color="green">047</FONT>    import ch.javasoft.jbase.util.AbstractDataInput;<a name="line.47"></a>
<FONT color="green">048</FONT>    import ch.javasoft.jbase.util.AbstractDataOutput;<a name="line.48"></a>
<FONT color="green">049</FONT>    import ch.javasoft.jbase.util.UnsupportedOperationException;<a name="line.49"></a>
<FONT color="green">050</FONT>    <a name="line.50"></a>
<FONT color="green">051</FONT>    /*<a name="line.51"></a>
<FONT color="green">052</FONT>     * TIME values<a name="line.52"></a>
<FONT color="green">053</FONT>     *      col 1: insert<a name="line.53"></a>
<FONT color="green">054</FONT>     *  col 2: update or ordered read<a name="line.54"></a>
<FONT color="green">055</FONT>     *  col 3: read or unordered read<a name="line.55"></a>
<FONT color="green">056</FONT>     * <a name="line.56"></a>
<FONT color="green">057</FONT>    ========<a name="line.57"></a>
<FONT color="green">058</FONT>    <a name="line.58"></a>
<FONT color="green">059</FONT>    without buffering<a name="line.59"></a>
<FONT color="green">060</FONT>    <a name="line.60"></a>
<FONT color="green">061</FONT>    testInt (ms) = 718, 2218, 3979<a name="line.61"></a>
<FONT color="green">062</FONT>    testBigInteger (ms) = 1263, 911, 1050<a name="line.62"></a>
<FONT color="green">063</FONT>    testBigIntegerCache (ms) = 2332, 2514, 1086, 162<a name="line.63"></a>
<FONT color="green">064</FONT>    testRemoveInt (ms) = 0, 0, 0<a name="line.64"></a>
<FONT color="green">065</FONT>    testRemoveBigInteger (ms) = 872, 3020, 377<a name="line.65"></a>
<FONT color="green">066</FONT>    testRemoveDeleteFileBigInteger (ms) = 4, 29<a name="line.66"></a>
<FONT color="green">067</FONT>    testRemoveAllBigInteger (ms) = 98, 2<a name="line.67"></a>
<FONT color="green">068</FONT>    testSetBigInteger (ms) = 907, 2420, 776<a name="line.68"></a>
<FONT color="green">069</FONT>    testSetBigInteger (ms) = 860, 1555, 798<a name="line.69"></a>
<FONT color="green">070</FONT>    <a name="line.70"></a>
<FONT color="green">071</FONT>    testInt (ms) = 587, 615, 607<a name="line.71"></a>
<FONT color="green">072</FONT>    testBigInteger (ms) = 1059, 959, 945<a name="line.72"></a>
<FONT color="green">073</FONT>    testBigIntegerCache (ms) = 905, 1468, 2620, 158<a name="line.73"></a>
<FONT color="green">074</FONT>    testRemoveInt (ms) = 0, 0, 0<a name="line.74"></a>
<FONT color="green">075</FONT>    testRemoveBigInteger (ms) = 954, 2974, 362<a name="line.75"></a>
<FONT color="green">076</FONT>    testRemoveDeleteFileBigInteger (ms) = 4, 1<a name="line.76"></a>
<FONT color="green">077</FONT>    testRemoveAllBigInteger (ms) = 95, 3<a name="line.77"></a>
<FONT color="green">078</FONT>    testSetBigInteger (ms) = 853, 2390, 753<a name="line.78"></a>
<FONT color="green">079</FONT>    testSetBigInteger (ms) = 901, 1609, 770<a name="line.79"></a>
<FONT color="green">080</FONT>    <a name="line.80"></a>
<FONT color="green">081</FONT>    ========<a name="line.81"></a>
<FONT color="green">082</FONT>    4K<a name="line.82"></a>
<FONT color="green">083</FONT>    <a name="line.83"></a>
<FONT color="green">084</FONT>    16x256<a name="line.84"></a>
<FONT color="green">085</FONT>    testInt (ms) = 463, 549, 773<a name="line.85"></a>
<FONT color="green">086</FONT>    testBigInteger (ms) = 751, 446, 1185<a name="line.86"></a>
<FONT color="green">087</FONT>    testBigIntegerCache (ms) = 460, 483, 339, 150<a name="line.87"></a>
<FONT color="green">088</FONT>    testRemoveInt (ms) = 0, 0, 0<a name="line.88"></a>
<FONT color="green">089</FONT>    testRemoveBigInteger (ms) = 433, 1843, 154<a name="line.89"></a>
<FONT color="green">090</FONT>    testRemoveDeleteFileBigInteger (ms) = 4, 1<a name="line.90"></a>
<FONT color="green">091</FONT>    testRemoveAllBigInteger (ms) = 48, 2<a name="line.91"></a>
<FONT color="green">092</FONT>    testSetBigInteger (ms) = 392, 6096, 311<a name="line.92"></a>
<FONT color="green">093</FONT>    testSetBigInteger (ms) = 384, 1955, 365<a name="line.93"></a>
<FONT color="green">094</FONT>    <a name="line.94"></a>
<FONT color="green">095</FONT>    64x64<a name="line.95"></a>
<FONT color="green">096</FONT>    testInt (ms) = 504, 591, 742<a name="line.96"></a>
<FONT color="green">097</FONT>    testBigInteger (ms) = 1321, 616, 1241<a name="line.97"></a>
<FONT color="green">098</FONT>    testBigIntegerCache (ms) = 1204, 579, 501, 150<a name="line.98"></a>
<FONT color="green">099</FONT>    testRemoveInt (ms) = 0, 0, 1<a name="line.99"></a>
<FONT color="green">100</FONT>    testRemoveBigInteger (ms) = 1115, 2340, 237<a name="line.100"></a>
<FONT color="green">101</FONT>    testRemoveDeleteFileBigInteger (ms) = 4, 1<a name="line.101"></a>
<FONT color="green">102</FONT>    testRemoveAllBigInteger (ms) = 120, 3<a name="line.102"></a>
<FONT color="green">103</FONT>    testSetBigInteger (ms) = 1132, 2168, 529<a name="line.103"></a>
<FONT color="green">104</FONT>    testSetBigInteger (ms) = 1056, 2109, 477<a name="line.104"></a>
<FONT color="green">105</FONT>    <a name="line.105"></a>
<FONT color="green">106</FONT>    128x32<a name="line.106"></a>
<FONT color="green">107</FONT>    testInt (ms) = 655, 609, 724<a name="line.107"></a>
<FONT color="green">108</FONT>    testBigInteger (ms) = 2120, 751, 1227<a name="line.108"></a>
<FONT color="green">109</FONT>    testBigIntegerCache (ms) = 1857, 811, 674, 237<a name="line.109"></a>
<FONT color="green">110</FONT>    testRemoveInt (ms) = 0, 0, 0<a name="line.110"></a>
<FONT color="green">111</FONT>    testRemoveBigInteger (ms) = 1810, 2882, 336<a name="line.111"></a>
<FONT color="green">112</FONT>    testRemoveDeleteFileBigInteger (ms) = 3, 1<a name="line.112"></a>
<FONT color="green">113</FONT>    testRemoveAllBigInteger (ms) = 205, 3<a name="line.113"></a>
<FONT color="green">114</FONT>    testSetBigInteger (ms) = 1845, 2333, 656<a name="line.114"></a>
<FONT color="green">115</FONT>    testSetBigInteger (ms) = 1817, 2351, 742<a name="line.115"></a>
<FONT color="green">116</FONT>    <a name="line.116"></a>
<FONT color="green">117</FONT>    32x128<a name="line.117"></a>
<FONT color="green">118</FONT>    testInt (ms) = 411, 569, 754<a name="line.118"></a>
<FONT color="green">119</FONT>    testBigInteger (ms) = 1427, 509, 1173<a name="line.119"></a>
<FONT color="green">120</FONT>    testBigIntegerCache (ms) = 665, 537, 406, 150<a name="line.120"></a>
<FONT color="green">121</FONT>    testRemoveInt (ms) = 0, 0, 1<a name="line.121"></a>
<FONT color="green">122</FONT>    testRemoveBigInteger (ms) = 665, 1963, 180<a name="line.122"></a>
<FONT color="green">123</FONT>    testRemoveDeleteFileBigInteger (ms) = 3, 1<a name="line.123"></a>
<FONT color="green">124</FONT>    testRemoveAllBigInteger (ms) = 72, 3<a name="line.124"></a>
<FONT color="green">125</FONT>    testSetBigInteger (ms) = 601, 2384, 360<a name="line.125"></a>
<FONT color="green">126</FONT>    testSetBigInteger (ms) = 682, 1955, 425<a name="line.126"></a>
<FONT color="green">127</FONT>    <a name="line.127"></a>
<FONT color="green">128</FONT>    ========<a name="line.128"></a>
<FONT color="green">129</FONT>    <a name="line.129"></a>
<FONT color="green">130</FONT>    ========<a name="line.130"></a>
<FONT color="green">131</FONT>    16K<a name="line.131"></a>
<FONT color="green">132</FONT>    <a name="line.132"></a>
<FONT color="green">133</FONT>    256x64<a name="line.133"></a>
<FONT color="green">134</FONT>    testInt (ms) = 502, 579, 716<a name="line.134"></a>
<FONT color="green">135</FONT>    testBigInteger (ms) = 1318, 601, 1188<a name="line.135"></a>
<FONT color="green">136</FONT>    testBigIntegerCache (ms) = 1203, 578, 491, 155<a name="line.136"></a>
<FONT color="green">137</FONT>    testRemoveInt (ms) = 0, 0, 0<a name="line.137"></a>
<FONT color="green">138</FONT>    testRemoveBigInteger (ms) = 1124, 2125, 229<a name="line.138"></a>
<FONT color="green">139</FONT>    testRemoveDeleteFileBigInteger (ms) = 3, 1<a name="line.139"></a>
<FONT color="green">140</FONT>    testRemoveAllBigInteger (ms) = 112, 3<a name="line.140"></a>
<FONT color="green">141</FONT>    testSetBigInteger (ms) = 1085, 1844, 510<a name="line.141"></a>
<FONT color="green">142</FONT>    testSetBigInteger (ms) = 1023, 2080, 459<a name="line.142"></a>
<FONT color="green">143</FONT>    <a name="line.143"></a>
<FONT color="green">144</FONT>    64x256<a name="line.144"></a>
<FONT color="green">145</FONT>    testInt (ms) = 455, 547, 759<a name="line.145"></a>
<FONT color="green">146</FONT>    testBigInteger (ms) = 734, 455, 1151<a name="line.146"></a>
<FONT color="green">147</FONT>    testBigIntegerCache (ms) = 424, 432, 344, 157<a name="line.147"></a>
<FONT color="green">148</FONT>    testRemoveInt (ms) = 0, 0, 1<a name="line.148"></a>
<FONT color="green">149</FONT>    testRemoveBigInteger (ms) = 432, 1662, 143<a name="line.149"></a>
<FONT color="green">150</FONT>    testRemoveDeleteFileBigInteger (ms) = 3, 1<a name="line.150"></a>
<FONT color="green">151</FONT>    testRemoveAllBigInteger (ms) = 48, 2<a name="line.151"></a>
<FONT color="green">152</FONT>    testSetBigInteger (ms) = 406, 2834, 277<a name="line.152"></a>
<FONT color="green">153</FONT>    testSetBigInteger (ms) = 387, 1905, 360<a name="line.153"></a>
<FONT color="green">154</FONT>    <a name="line.154"></a>
<FONT color="green">155</FONT>    ========<a name="line.155"></a>
<FONT color="green">156</FONT>    64K<a name="line.156"></a>
<FONT color="green">157</FONT>    <a name="line.157"></a>
<FONT color="green">158</FONT>    256x256<a name="line.158"></a>
<FONT color="green">159</FONT>    testInt (ms) = 439, 561, 702<a name="line.159"></a>
<FONT color="green">160</FONT>    testBigInteger (ms) = 714, 434, 1127<a name="line.160"></a>
<FONT color="green">161</FONT>    testBigIntegerCache (ms) = 472, 518, 348, 154<a name="line.161"></a>
<FONT color="green">162</FONT>    testRemoveInt (ms) = 0, 0, 0<a name="line.162"></a>
<FONT color="green">163</FONT>    testRemoveBigInteger (ms) = 434, 1529, 124<a name="line.163"></a>
<FONT color="green">164</FONT>    testRemoveDeleteFileBigInteger (ms) = 4, 1<a name="line.164"></a>
<FONT color="green">165</FONT>    testRemoveAllBigInteger (ms) = 46, 3<a name="line.165"></a>
<FONT color="green">166</FONT>    testSetBigInteger (ms) = 372, 1985, 254<a name="line.166"></a>
<FONT color="green">167</FONT>    testSetBigInteger (ms) = 376, 1768, 333<a name="line.167"></a>
<FONT color="green">168</FONT>    <a name="line.168"></a>
<FONT color="green">169</FONT>    64x1024<a name="line.169"></a>
<FONT color="green">170</FONT>    testInt (ms) = 428, 475, 990<a name="line.170"></a>
<FONT color="green">171</FONT>    testBigInteger (ms) = 460, 410, 1297<a name="line.171"></a>
<FONT color="green">172</FONT>    testBigIntegerCache (ms) = 198, 391, 306, 155<a name="line.172"></a>
<FONT color="green">173</FONT>    testRemoveInt (ms) = 0, 0, 0<a name="line.173"></a>
<FONT color="green">174</FONT>    testRemoveBigInteger (ms) = 201, 1538, 95<a name="line.174"></a>
<FONT color="green">175</FONT>    testRemoveDeleteFileBigInteger (ms) = 5, 1<a name="line.175"></a>
<FONT color="green">176</FONT>    testRemoveAllBigInteger (ms) = 27, 3<a name="line.176"></a>
<FONT color="green">177</FONT>    testSetBigInteger (ms) = 244, 2665, 249<a name="line.177"></a>
<FONT color="green">178</FONT>    testSetBigInteger (ms) = 233, 1998, 272<a name="line.178"></a>
<FONT color="green">179</FONT>    <a name="line.179"></a>
<FONT color="green">180</FONT>    1024x256<a name="line.180"></a>
<FONT color="green">181</FONT>    testInt (ms) = 584, 593, 633<a name="line.181"></a>
<FONT color="green">182</FONT>    testBigInteger (ms) = 1288, 608, 1149<a name="line.182"></a>
<FONT color="green">183</FONT>    testBigIntegerCache (ms) = 1127, 636, 519, 157<a name="line.183"></a>
<FONT color="green">184</FONT>    testRemoveInt (ms) = 0, 0, 0<a name="line.184"></a>
<FONT color="green">185</FONT>    testRemoveBigInteger (ms) = 1105, 1983, 210<a name="line.185"></a>
<FONT color="green">186</FONT>    testRemoveDeleteFileBigInteger (ms) = 4, 1<a name="line.186"></a>
<FONT color="green">187</FONT>    testRemoveAllBigInteger (ms) = 112, 2<a name="line.187"></a>
<FONT color="green">188</FONT>    testSetBigInteger (ms) = 1098, 1699, 470<a name="line.188"></a>
<FONT color="green">189</FONT>    testSetBigInteger (ms) = 1047, 1946, 421<a name="line.189"></a>
<FONT color="green">190</FONT>    <a name="line.190"></a>
<FONT color="green">191</FONT>    128x512<a name="line.191"></a>
<FONT color="green">192</FONT>    testInt (ms) = 353, 565, 725<a name="line.192"></a>
<FONT color="green">193</FONT>    testBigInteger (ms) = 726, 421, 1098<a name="line.193"></a>
<FONT color="green">194</FONT>    testBigIntegerCache (ms) = 333, 328, 288, 156<a name="line.194"></a>
<FONT color="green">195</FONT>    testRemoveInt (ms) = 0, 1, 0<a name="line.195"></a>
<FONT color="green">196</FONT>    testRemoveBigInteger (ms) = 251, 1429, 105<a name="line.196"></a>
<FONT color="green">197</FONT>    testRemoveDeleteFileBigInteger (ms) = 4, 1<a name="line.197"></a>
<FONT color="green">198</FONT>    testRemoveAllBigInteger (ms) = 34, 4<a name="line.198"></a>
<FONT color="green">199</FONT>    testSetBigInteger (ms) = 304, 2096, 249<a name="line.199"></a>
<FONT color="green">200</FONT>    testSetBigInteger (ms) = 289, 1809, 250<a name="line.200"></a>
<FONT color="green">201</FONT>     */<a name="line.201"></a>
<FONT color="green">202</FONT>    /**<a name="line.202"></a>
<FONT color="green">203</FONT>     * The &lt;tt&gt;BufferedRandomAccessPersister&lt;/tt&gt; caches data in a hash table, and<a name="line.203"></a>
<FONT color="green">204</FONT>     * delegates the real i/o operations to an underlying delegate<a name="line.204"></a>
<FONT color="green">205</FONT>     * {@link RandomAccessPersister}.<a name="line.205"></a>
<FONT color="green">206</FONT>     * &lt;p&gt;<a name="line.206"></a>
<FONT color="green">207</FONT>     * Note that all cache-access is thread safe. If the caller guarantees that<a name="line.207"></a>
<FONT color="green">208</FONT>     * atomic read and write operations do not overlap, the class is thread-safe,<a name="line.208"></a>
<FONT color="green">209</FONT>     * even if concurrent read operations are overlapping.<a name="line.209"></a>
<FONT color="green">210</FONT>     */<a name="line.210"></a>
<FONT color="green">211</FONT>    public class BufferedRandomAccessPersister implements RandomAccessPersister {<a name="line.211"></a>
<FONT color="green">212</FONT>            <a name="line.212"></a>
<FONT color="green">213</FONT>            private final RandomAccessPersister     delegate;<a name="line.213"></a>
<FONT color="green">214</FONT>            private final int                                       tableSize;<a name="line.214"></a>
<FONT color="green">215</FONT>            private final int                                       entrySize;<a name="line.215"></a>
<FONT color="green">216</FONT>            private final DataInput                         dataInput;<a name="line.216"></a>
<FONT color="green">217</FONT>            private final DataOutput                        dataOutput;//null for read-copy<a name="line.217"></a>
<FONT color="green">218</FONT>            private final ReadWriteLock                     lock;<a name="line.218"></a>
<FONT color="green">219</FONT>    <a name="line.219"></a>
<FONT color="green">220</FONT>            //hash table entry<a name="line.220"></a>
<FONT color="green">221</FONT>            private final static class TableEntry {<a name="line.221"></a>
<FONT color="green">222</FONT>                    public TableEntry(long start, int size) {<a name="line.222"></a>
<FONT color="green">223</FONT>                            this.start      = start;<a name="line.223"></a>
<FONT color="green">224</FONT>                            this.buffer     = new byte[size];<a name="line.224"></a>
<FONT color="green">225</FONT>                            this.length = size;<a name="line.225"></a>
<FONT color="green">226</FONT>                    }<a name="line.226"></a>
<FONT color="green">227</FONT>                    public final long       start;  //start byte position<a name="line.227"></a>
<FONT color="green">228</FONT>                    public final byte[]     buffer;<a name="line.228"></a>
<FONT color="green">229</FONT>                    public volatile int length;<a name="line.229"></a>
<FONT color="green">230</FONT>                    public volatile boolean dirty;<a name="line.230"></a>
<FONT color="green">231</FONT>                    <a name="line.231"></a>
<FONT color="green">232</FONT>                    @Override<a name="line.232"></a>
<FONT color="green">233</FONT>                    public String toString() {<a name="line.233"></a>
<FONT color="green">234</FONT>                            return getClass().getSimpleName() + "[" + start + ".." + (start + length - 1) + "={" +<a name="line.234"></a>
<FONT color="green">235</FONT>                                    (length == 0 ? "" : (buffer[0] + ".." + buffer[length - 1]) + "}]");<a name="line.235"></a>
<FONT color="green">236</FONT>                    }<a name="line.236"></a>
<FONT color="green">237</FONT>            }<a name="line.237"></a>
<FONT color="green">238</FONT>            private final AtomicReferenceArray&lt;TableEntry&gt; cache;<a name="line.238"></a>
<FONT color="green">239</FONT>            <a name="line.239"></a>
<FONT color="green">240</FONT>            private final ThreadLocal&lt;long[]&gt; pos = new ThreadLocal&lt;long[]&gt;() {<a name="line.240"></a>
<FONT color="green">241</FONT>                    @Override<a name="line.241"></a>
<FONT color="green">242</FONT>                    protected long[] initialValue() {return new long[]{0};}<a name="line.242"></a>
<FONT color="green">243</FONT>            };<a name="line.243"></a>
<FONT color="green">244</FONT>            <a name="line.244"></a>
<FONT color="green">245</FONT>            /**<a name="line.245"></a>
<FONT color="green">246</FONT>             * Constructor using a {@link RandomAccessFilePersistor} as delegate, and<a name="line.246"></a>
<FONT color="green">247</FONT>             * a cache acording to the specified specifications. <a name="line.247"></a>
<FONT color="green">248</FONT>             * &lt;p&gt;<a name="line.248"></a>
<FONT color="green">249</FONT>             * &lt;b&gt;Notes:&lt;/b&gt;<a name="line.249"></a>
<FONT color="green">250</FONT>             * &lt;ul&gt;<a name="line.250"></a>
<FONT color="green">251</FONT>             * &lt;li&gt;the maximum cache size is &lt;tt&gt;tableSize * entrySize&lt;/tt&gt;&lt;/li&gt;<a name="line.251"></a>
<FONT color="green">252</FONT>             * &lt;li&gt;larger &lt;tt&gt;tableSize&lt;/tt&gt; has positive influence on all functions,<a name="line.252"></a>
<FONT color="green">253</FONT>             *              but especially random read access can profit&lt;/li&gt;<a name="line.253"></a>
<FONT color="green">254</FONT>             * &lt;li&gt;larger &lt;tt&gt;entrySize&lt;/tt&gt; has positive influence for sequential write <a name="line.254"></a>
<FONT color="green">255</FONT>             *              operations, but might have negative affect in combination with<a name="line.255"></a>
<FONT color="green">256</FONT>             *              small &lt;tt&gt;tableSize&lt;/tt&gt; and random modifying operations&lt;/li&gt;<a name="line.256"></a>
<FONT color="green">257</FONT>             * &lt;/ul&gt;<a name="line.257"></a>
<FONT color="green">258</FONT>             * &lt;p&gt;<a name="line.258"></a>
<FONT color="green">259</FONT>             * &lt;b&gt;Recommended values:&lt;/b&gt;<a name="line.259"></a>
<FONT color="green">260</FONT>             * &lt;ul&gt;<a name="line.260"></a>
<FONT color="green">261</FONT>             * &lt;li&gt;&lt;tt&gt;tableSize = 64, entrySize = 256&lt;/tt&gt;: good setting for general<a name="line.261"></a>
<FONT color="green">262</FONT>             *              purpose use, maximum cache size is 16K&lt;/li&gt;<a name="line.262"></a>
<FONT color="green">263</FONT>             * &lt;li&gt;&lt;tt&gt;tableSize = 256, entrySize = 64&lt;/tt&gt;: faster read operations, on<a name="line.263"></a>
<FONT color="green">264</FONT>             *              the price of slower writing, maximum cache size is 16K&lt;/li&gt;<a name="line.264"></a>
<FONT color="green">265</FONT>             * &lt;/ul&gt;<a name="line.265"></a>
<FONT color="green">266</FONT>             * <a name="line.266"></a>
<FONT color="green">267</FONT>             * @param file                  file to create a {@link RandomAccessFilePersistor}<a name="line.267"></a>
<FONT color="green">268</FONT>             * @param tableSize             number of entries in the hash table<a name="line.268"></a>
<FONT color="green">269</FONT>             * @param entrySize             buffer byte length of a single hash table entry<a name="line.269"></a>
<FONT color="green">270</FONT>             * @throws FileNotFoundException if the specified file is not found<a name="line.270"></a>
<FONT color="green">271</FONT>             */<a name="line.271"></a>
<FONT color="green">272</FONT>            public BufferedRandomAccessPersister(File file, int tableSize, int entrySize) throws FileNotFoundException {<a name="line.272"></a>
<FONT color="green">273</FONT>                    this(new RandomAccessFilePersistor(file), tableSize, entrySize);<a name="line.273"></a>
<FONT color="green">274</FONT>            }<a name="line.274"></a>
<FONT color="green">275</FONT>            /**<a name="line.275"></a>
<FONT color="green">276</FONT>             * Constructor with delegate persistor and cache specifications. <a name="line.276"></a>
<FONT color="green">277</FONT>             * &lt;p&gt;<a name="line.277"></a>
<FONT color="green">278</FONT>             * &lt;b&gt;Notes:&lt;/b&gt;<a name="line.278"></a>
<FONT color="green">279</FONT>             * &lt;ul&gt;<a name="line.279"></a>
<FONT color="green">280</FONT>             * &lt;li&gt;the maximum cache size is &lt;tt&gt;tableSize * entrySize&lt;/tt&gt;&lt;/li&gt;<a name="line.280"></a>
<FONT color="green">281</FONT>             * &lt;li&gt;larger &lt;tt&gt;tableSize&lt;/tt&gt; has positive influence on all functions,<a name="line.281"></a>
<FONT color="green">282</FONT>             *              but especially random read access can profit&lt;/li&gt;<a name="line.282"></a>
<FONT color="green">283</FONT>             * &lt;li&gt;larger &lt;tt&gt;entrySize&lt;/tt&gt; has positive influence for sequential write <a name="line.283"></a>
<FONT color="green">284</FONT>             *              operations, but might have negative affect in combination with<a name="line.284"></a>
<FONT color="green">285</FONT>             *              small &lt;tt&gt;tableSize&lt;/tt&gt; and random modifying operations&lt;/li&gt;<a name="line.285"></a>
<FONT color="green">286</FONT>             * &lt;/ul&gt;<a name="line.286"></a>
<FONT color="green">287</FONT>             * &lt;p&gt;<a name="line.287"></a>
<FONT color="green">288</FONT>             * &lt;b&gt;Recommended values:&lt;/b&gt;<a name="line.288"></a>
<FONT color="green">289</FONT>             * &lt;ul&gt;<a name="line.289"></a>
<FONT color="green">290</FONT>             * &lt;li&gt;&lt;tt&gt;tableSize = 64, entrySize = 256&lt;/tt&gt;: good setting for general<a name="line.290"></a>
<FONT color="green">291</FONT>             *              purpose use, maximum cache size is 16K&lt;/li&gt;<a name="line.291"></a>
<FONT color="green">292</FONT>             * &lt;li&gt;&lt;tt&gt;tableSize = 256, entrySize = 64&lt;/tt&gt;: faster read operations, on<a name="line.292"></a>
<FONT color="green">293</FONT>             *              the price of slower writing, maximum cache size is 16K&lt;/li&gt;<a name="line.293"></a>
<FONT color="green">294</FONT>             * &lt;/ul&gt;<a name="line.294"></a>
<FONT color="green">295</FONT>             * <a name="line.295"></a>
<FONT color="green">296</FONT>             * @param delegate              delegate persistor, does the real i/o operations<a name="line.296"></a>
<FONT color="green">297</FONT>             * @param tableSize             number of entries in the hash table<a name="line.297"></a>
<FONT color="green">298</FONT>             * @param entrySize             buffer byte length of a single hash table entry<a name="line.298"></a>
<FONT color="green">299</FONT>             */<a name="line.299"></a>
<FONT color="green">300</FONT>            public BufferedRandomAccessPersister(RandomAccessPersister delegate, int tableSize, int entrySize) {<a name="line.300"></a>
<FONT color="green">301</FONT>                    this(delegate, tableSize, entrySize, false, new AtomicReferenceArray&lt;TableEntry&gt;(tableSize), new ReentrantReadWriteLock());<a name="line.301"></a>
<FONT color="green">302</FONT>            }<a name="line.302"></a>
<FONT color="green">303</FONT>            private BufferedRandomAccessPersister(RandomAccessPersister delegate, int tableSize, int entrySize, boolean readCopy, AtomicReferenceArray&lt;TableEntry&gt; cache, ReadWriteLock lock) {<a name="line.303"></a>
<FONT color="green">304</FONT>                    if (delegate == null) throw new NullPointerException("delegate cannot be null");<a name="line.304"></a>
<FONT color="green">305</FONT>                    if (tableSize &lt;= 0) throw new IllegalArgumentException("table size must be positive: " + tableSize);<a name="line.305"></a>
<FONT color="green">306</FONT>                    if (entrySize &lt;= 0) throw new IllegalArgumentException("entry size must be positive: " + entrySize);<a name="line.306"></a>
<FONT color="green">307</FONT>                    this.delegate           = delegate;<a name="line.307"></a>
<FONT color="green">308</FONT>                    this.tableSize          = tableSize;<a name="line.308"></a>
<FONT color="green">309</FONT>                    this.entrySize          = entrySize;<a name="line.309"></a>
<FONT color="green">310</FONT>                    this.cache                      = cache;<a name="line.310"></a>
<FONT color="green">311</FONT>                    this.dataInput          = new BufferedDataInput();<a name="line.311"></a>
<FONT color="green">312</FONT>                    this.dataOutput         = readCopy ? null : new BufferedDataOutput();<a name="line.312"></a>
<FONT color="green">313</FONT>                    this.lock                       = lock;<a name="line.313"></a>
<FONT color="green">314</FONT>            }<a name="line.314"></a>
<FONT color="green">315</FONT>    <a name="line.315"></a>
<FONT color="green">316</FONT>            public DataInput getInput() throws IOException {<a name="line.316"></a>
<FONT color="green">317</FONT>                    if (pos.get() == null) throw new IOException("persister already closed");<a name="line.317"></a>
<FONT color="green">318</FONT>                    return dataInput;<a name="line.318"></a>
<FONT color="green">319</FONT>            }<a name="line.319"></a>
<FONT color="green">320</FONT>    <a name="line.320"></a>
<FONT color="green">321</FONT>            public DataOutput getOutput() throws IOException {<a name="line.321"></a>
<FONT color="green">322</FONT>                    if (pos.get() == null) throw new IOException("persister already closed");<a name="line.322"></a>
<FONT color="green">323</FONT>                    return dataOutput;<a name="line.323"></a>
<FONT color="green">324</FONT>            }<a name="line.324"></a>
<FONT color="green">325</FONT>    <a name="line.325"></a>
<FONT color="green">326</FONT>            public long getPosition() throws IOException {<a name="line.326"></a>
<FONT color="green">327</FONT>                    if (pos.get() == null) throw new IOException("persister already closed");<a name="line.327"></a>
<FONT color="green">328</FONT>                    return pos.get()[0];<a name="line.328"></a>
<FONT color="green">329</FONT>            }<a name="line.329"></a>
<FONT color="green">330</FONT>    <a name="line.330"></a>
<FONT color="green">331</FONT>            public void setPosition(long bytePos) throws IOException {<a name="line.331"></a>
<FONT color="green">332</FONT>                    if (pos.get() == null) throw new IOException("persister already closed");<a name="line.332"></a>
<FONT color="green">333</FONT>                    pos.get()[0] = bytePos;<a name="line.333"></a>
<FONT color="green">334</FONT>            }<a name="line.334"></a>
<FONT color="green">335</FONT>    <a name="line.335"></a>
<FONT color="green">336</FONT>            public void setLength(long byteLength) throws IOException {<a name="line.336"></a>
<FONT color="green">337</FONT>                    if (pos.get() == null) throw new IOException("persister already closed");<a name="line.337"></a>
<FONT color="green">338</FONT>                    lock.writeLock().lock();<a name="line.338"></a>
<FONT color="green">339</FONT>                    try {<a name="line.339"></a>
<FONT color="green">340</FONT>                            for (int i = 0; i &lt; cache.length(); i++) {<a name="line.340"></a>
<FONT color="green">341</FONT>                                    final TableEntry e = cache.get(i);<a name="line.341"></a>
<FONT color="green">342</FONT>                                    if (e != null) {<a name="line.342"></a>
<FONT color="green">343</FONT>                                            if (e.start &gt;= byteLength) {<a name="line.343"></a>
<FONT color="green">344</FONT>                                                    //just remove entry<a name="line.344"></a>
<FONT color="green">345</FONT>                                                    cache.set(i, null);<a name="line.345"></a>
<FONT color="green">346</FONT>                                            }<a name="line.346"></a>
<FONT color="green">347</FONT>                                            else {<a name="line.347"></a>
<FONT color="green">348</FONT>                                                    final long newlen = byteLength - e.start;<a name="line.348"></a>
<FONT color="green">349</FONT>                                                    if (newlen &lt; e.length) {<a name="line.349"></a>
<FONT color="green">350</FONT>                                                            //resize the entry<a name="line.350"></a>
<FONT color="green">351</FONT>                                                            e.length = (int)newlen;<a name="line.351"></a>
<FONT color="green">352</FONT>                                                            e.dirty  = true;<a name="line.352"></a>
<FONT color="green">353</FONT>                                                    }<a name="line.353"></a>
<FONT color="green">354</FONT>                                            }<a name="line.354"></a>
<FONT color="green">355</FONT>                                    }<a name="line.355"></a>
<FONT color="green">356</FONT>                            }<a name="line.356"></a>
<FONT color="green">357</FONT>                    }<a name="line.357"></a>
<FONT color="green">358</FONT>                    finally {<a name="line.358"></a>
<FONT color="green">359</FONT>                            lock.writeLock().unlock();<a name="line.359"></a>
<FONT color="green">360</FONT>                    }<a name="line.360"></a>
<FONT color="green">361</FONT>                    delegate.setLength(byteLength);<a name="line.361"></a>
<FONT color="green">362</FONT>            }<a name="line.362"></a>
<FONT color="green">363</FONT>    <a name="line.363"></a>
<FONT color="green">364</FONT>            public void flush() throws IOException {<a name="line.364"></a>
<FONT color="green">365</FONT>                    if (pos.get() == null) throw new IOException("persister already closed");<a name="line.365"></a>
<FONT color="green">366</FONT>                    lock.readLock().lock();<a name="line.366"></a>
<FONT color="green">367</FONT>                    try {<a name="line.367"></a>
<FONT color="green">368</FONT>                            for (int i = 0; i &lt; cache.length(); i++) {<a name="line.368"></a>
<FONT color="green">369</FONT>                                    final TableEntry e = cache.get(i);<a name="line.369"></a>
<FONT color="green">370</FONT>                                    if (e != null &amp;&amp; e.dirty) {<a name="line.370"></a>
<FONT color="green">371</FONT>                                            flushDirtyEntry(delegate, e);<a name="line.371"></a>
<FONT color="green">372</FONT>                                    }<a name="line.372"></a>
<FONT color="green">373</FONT>                            }<a name="line.373"></a>
<FONT color="green">374</FONT>                    }<a name="line.374"></a>
<FONT color="green">375</FONT>                    finally {<a name="line.375"></a>
<FONT color="green">376</FONT>                            lock.readLock().unlock();<a name="line.376"></a>
<FONT color="green">377</FONT>                    }<a name="line.377"></a>
<FONT color="green">378</FONT>                    delegate.flush();<a name="line.378"></a>
<FONT color="green">379</FONT>            }<a name="line.379"></a>
<FONT color="green">380</FONT>            <a name="line.380"></a>
<FONT color="green">381</FONT>            /**<a name="line.381"></a>
<FONT color="green">382</FONT>             * PRECONDITION: read or write lock held<a name="line.382"></a>
<FONT color="green">383</FONT>             */<a name="line.383"></a>
<FONT color="green">384</FONT>            protected void flushDirtyEntry(RandomAccessPersister delegate, TableEntry entry) throws IOException {<a name="line.384"></a>
<FONT color="green">385</FONT>                    synchronized (delegate) {<a name="line.385"></a>
<FONT color="green">386</FONT>                            if (entry.dirty) {//could already have been saved by someone else<a name="line.386"></a>
<FONT color="green">387</FONT>                                    delegate.setPosition(entry.start);<a name="line.387"></a>
<FONT color="green">388</FONT>                                    delegate.getOutput().write(entry.buffer, 0, entry.length);<a name="line.388"></a>
<FONT color="green">389</FONT>                                    entry.dirty = false;//could be used by someone else<a name="line.389"></a>
<FONT color="green">390</FONT>                            }<a name="line.390"></a>
<FONT color="green">391</FONT>                    }<a name="line.391"></a>
<FONT color="green">392</FONT>            }<a name="line.392"></a>
<FONT color="green">393</FONT>    <a name="line.393"></a>
<FONT color="green">394</FONT>            public void close(boolean erase) throws IOException {<a name="line.394"></a>
<FONT color="green">395</FONT>                    if (erase &amp;&amp; dataOutput == null) {<a name="line.395"></a>
<FONT color="green">396</FONT>                            throw new UnsupportedOperationException("unmodifyable read copy");                                                      <a name="line.396"></a>
<FONT color="green">397</FONT>                    }<a name="line.397"></a>
<FONT color="green">398</FONT>                    if (pos.get() != null) {<a name="line.398"></a>
<FONT color="green">399</FONT>                            pos.set(null);<a name="line.399"></a>
<FONT color="green">400</FONT>                            lock.readLock().lock();<a name="line.400"></a>
<FONT color="green">401</FONT>                            try {<a name="line.401"></a>
<FONT color="green">402</FONT>                                    for (int i = 0; i &lt; cache.length(); i++) {<a name="line.402"></a>
<FONT color="green">403</FONT>                                            final TableEntry e;<a name="line.403"></a>
<FONT color="green">404</FONT>                                            if (dataOutput != null) {<a name="line.404"></a>
<FONT color="green">405</FONT>                                                    //clear cache if this is not a read copy<a name="line.405"></a>
<FONT color="green">406</FONT>                                                    e = cache.getAndSet(i, null);<a name="line.406"></a>
<FONT color="green">407</FONT>                                            }<a name="line.407"></a>
<FONT color="green">408</FONT>                                            else {<a name="line.408"></a>
<FONT color="green">409</FONT>                                                    e = cache.get(i);<a name="line.409"></a>
<FONT color="green">410</FONT>                                            }<a name="line.410"></a>
<FONT color="green">411</FONT>                                            if (e != null &amp;&amp; e.dirty) {<a name="line.411"></a>
<FONT color="green">412</FONT>                                                    flushDirtyEntry(delegate, e);<a name="line.412"></a>
<FONT color="green">413</FONT>                                            }<a name="line.413"></a>
<FONT color="green">414</FONT>                                    }<a name="line.414"></a>
<FONT color="green">415</FONT>                            }<a name="line.415"></a>
<FONT color="green">416</FONT>                            finally {<a name="line.416"></a>
<FONT color="green">417</FONT>                                    lock.readLock().unlock();                                       <a name="line.417"></a>
<FONT color="green">418</FONT>                            }<a name="line.418"></a>
<FONT color="green">419</FONT>                            delegate.close(erase);<a name="line.419"></a>
<FONT color="green">420</FONT>                    }<a name="line.420"></a>
<FONT color="green">421</FONT>            }<a name="line.421"></a>
<FONT color="green">422</FONT>    <a name="line.422"></a>
<FONT color="green">423</FONT>            public RandomAccessPersister createReadCopy(final ReadWriteLock lock) throws IOException {<a name="line.423"></a>
<FONT color="green">424</FONT>                    flush();<a name="line.424"></a>
<FONT color="green">425</FONT>                    final RandomAccessPersister copy = new BufferedRandomAccessPersister(<a name="line.425"></a>
<FONT color="green">426</FONT>                            delegate.createReadCopy(lock), tableSize, entrySize, true, <a name="line.426"></a>
<FONT color="green">427</FONT>                            cache, BufferedRandomAccessPersister.this.lock) {<a name="line.427"></a>
<FONT color="green">428</FONT>                            @Override<a name="line.428"></a>
<FONT color="green">429</FONT>                            public DataOutput getOutput() throws IOException {<a name="line.429"></a>
<FONT color="green">430</FONT>                                    throw new UnsupportedOperationException("read only copy, data output not supported");<a name="line.430"></a>
<FONT color="green">431</FONT>                            }<a name="line.431"></a>
<FONT color="green">432</FONT>                            @Override<a name="line.432"></a>
<FONT color="green">433</FONT>                            public void setLength(long byteLength) throws IOException {<a name="line.433"></a>
<FONT color="green">434</FONT>                                    throw new UnsupportedOperationException("read only copy, setting length not supported");<a name="line.434"></a>
<FONT color="green">435</FONT>                            }<a name="line.435"></a>
<FONT color="green">436</FONT>                            @Override<a name="line.436"></a>
<FONT color="green">437</FONT>                            public void flush() throws IOException {<a name="line.437"></a>
<FONT color="green">438</FONT>                                    throw new UnsupportedOperationException("read only copy, flush not supported");<a name="line.438"></a>
<FONT color="green">439</FONT>                            }<a name="line.439"></a>
<FONT color="green">440</FONT>                            @Override<a name="line.440"></a>
<FONT color="green">441</FONT>                            protected void flushDirtyEntry(RandomAccessPersister copyDelegate, TableEntry entry) throws IOException {<a name="line.441"></a>
<FONT color="green">442</FONT>                                    super.flushDirtyEntry(BufferedRandomAccessPersister.this.delegate, entry);<a name="line.442"></a>
<FONT color="green">443</FONT>                            }<a name="line.443"></a>
<FONT color="green">444</FONT>                    };<a name="line.444"></a>
<FONT color="green">445</FONT>                    copy.setPosition(getPosition());<a name="line.445"></a>
<FONT color="green">446</FONT>                    return copy;<a name="line.446"></a>
<FONT color="green">447</FONT>            }<a name="line.447"></a>
<FONT color="green">448</FONT>            <a name="line.448"></a>
<FONT color="green">449</FONT>            /**<a name="line.449"></a>
<FONT color="green">450</FONT>             * PRECONDITION: read or write lock held<a name="line.450"></a>
<FONT color="green">451</FONT>             */<a name="line.451"></a>
<FONT color="green">452</FONT>            private TableEntry loadEntry(long start, int tInd, boolean forWrite) throws IOException {<a name="line.452"></a>
<FONT color="green">453</FONT>                    //read the desired entry<a name="line.453"></a>
<FONT color="green">454</FONT>                    final TableEntry e = new TableEntry(start, entrySize);<a name="line.454"></a>
<FONT color="green">455</FONT>                    delegate.setPosition(start);<a name="line.455"></a>
<FONT color="green">456</FONT>                    try {<a name="line.456"></a>
<FONT color="green">457</FONT>                            delegate.getInput().readFully(e.buffer);<a name="line.457"></a>
<FONT color="green">458</FONT>                    }<a name="line.458"></a>
<FONT color="green">459</FONT>                    catch (EOFException ex) {<a name="line.459"></a>
<FONT color="green">460</FONT>                            //end of stream, read byte by byte<a name="line.460"></a>
<FONT color="green">461</FONT>                            delegate.setPosition(start);<a name="line.461"></a>
<FONT color="green">462</FONT>                            for (int i = 0; i &lt; entrySize; i++) {<a name="line.462"></a>
<FONT color="green">463</FONT>                                    try {<a name="line.463"></a>
<FONT color="green">464</FONT>                                            e.buffer[i] = delegate.getInput().readByte();<a name="line.464"></a>
<FONT color="green">465</FONT>                                    }<a name="line.465"></a>
<FONT color="green">466</FONT>                                    catch (EOFException ex2) {<a name="line.466"></a>
<FONT color="green">467</FONT>                                            e.length = i;<a name="line.467"></a>
<FONT color="green">468</FONT>                                            break;<a name="line.468"></a>
<FONT color="green">469</FONT>                                    }<a name="line.469"></a>
<FONT color="green">470</FONT>                            }<a name="line.470"></a>
<FONT color="green">471</FONT>                    }<a name="line.471"></a>
<FONT color="green">472</FONT>                    if (e.length &gt; 0 || forWrite) {<a name="line.472"></a>
<FONT color="green">473</FONT>                            //save the old entry, if necessary<a name="line.473"></a>
<FONT color="green">474</FONT>                            final TableEntry old = cache.getAndSet(tInd, e);<a name="line.474"></a>
<FONT color="green">475</FONT>                            if (old != null &amp;&amp; old.dirty) {<a name="line.475"></a>
<FONT color="green">476</FONT>                                    flushDirtyEntry(delegate, old);<a name="line.476"></a>
<FONT color="green">477</FONT>                            }<a name="line.477"></a>
<FONT color="green">478</FONT>                    }<a name="line.478"></a>
<FONT color="green">479</FONT>                    return e;<a name="line.479"></a>
<FONT color="green">480</FONT>            }<a name="line.480"></a>
<FONT color="green">481</FONT>            /**<a name="line.481"></a>
<FONT color="green">482</FONT>             * PRECONDITION: read lock held <a name="line.482"></a>
<FONT color="green">483</FONT>             */<a name="line.483"></a>
<FONT color="green">484</FONT>            private TableEntry getEntryForRead() throws IOException {<a name="line.484"></a>
<FONT color="green">485</FONT>                    final long index        = pos.get()[0] / entrySize;<a name="line.485"></a>
<FONT color="green">486</FONT>                    final long start        = index * entrySize;<a name="line.486"></a>
<FONT color="green">487</FONT>                    final int tInd          = hash(index) % tableSize;<a name="line.487"></a>
<FONT color="green">488</FONT>                    <a name="line.488"></a>
<FONT color="green">489</FONT>                    final TableEntry e = cache.get(tInd);<a name="line.489"></a>
<FONT color="green">490</FONT>                    if (e != null &amp;&amp; e.start == start) {<a name="line.490"></a>
<FONT color="green">491</FONT>                            return e;<a name="line.491"></a>
<FONT color="green">492</FONT>                    }<a name="line.492"></a>
<FONT color="green">493</FONT>                    return loadEntry(start, tInd, false);<a name="line.493"></a>
<FONT color="green">494</FONT>            }<a name="line.494"></a>
<FONT color="green">495</FONT>            /**<a name="line.495"></a>
<FONT color="green">496</FONT>             * PRECONDITION: write lock held <a name="line.496"></a>
<FONT color="green">497</FONT>             */<a name="line.497"></a>
<FONT color="green">498</FONT>            private TableEntry getEntryForWrite() throws IOException {<a name="line.498"></a>
<FONT color="green">499</FONT>                    final long index        = pos.get()[0] / entrySize;<a name="line.499"></a>
<FONT color="green">500</FONT>                    final long start        = index * entrySize;<a name="line.500"></a>
<FONT color="green">501</FONT>                    final int tInd          = hash(index) % tableSize;<a name="line.501"></a>
<FONT color="green">502</FONT>                    <a name="line.502"></a>
<FONT color="green">503</FONT>                    //try first from cache<a name="line.503"></a>
<FONT color="green">504</FONT>                    final TableEntry e = cache.get(tInd);<a name="line.504"></a>
<FONT color="green">505</FONT>                    if (e != null &amp;&amp; e.start == start) {<a name="line.505"></a>
<FONT color="green">506</FONT>                            return e;<a name="line.506"></a>
<FONT color="green">507</FONT>                    }<a name="line.507"></a>
<FONT color="green">508</FONT>                    return loadEntry(start, tInd, true);<a name="line.508"></a>
<FONT color="green">509</FONT>            }<a name="line.509"></a>
<FONT color="green">510</FONT>            <a name="line.510"></a>
<FONT color="green">511</FONT>            private int read(boolean inc) throws IOException {<a name="line.511"></a>
<FONT color="green">512</FONT>                    if (pos.get() == null) throw new IOException("persister already closed");<a name="line.512"></a>
<FONT color="green">513</FONT>    <a name="line.513"></a>
<FONT color="green">514</FONT>                    final long[] apos = pos.get();<a name="line.514"></a>
<FONT color="green">515</FONT>                    final int eInd  = (int)(apos[0] % entrySize);<a name="line.515"></a>
<FONT color="green">516</FONT>    <a name="line.516"></a>
<FONT color="green">517</FONT>                    lock.readLock().lock();<a name="line.517"></a>
<FONT color="green">518</FONT>                    try {<a name="line.518"></a>
<FONT color="green">519</FONT>                            final TableEntry e = getEntryForRead();<a name="line.519"></a>
<FONT color="green">520</FONT>                            if (eInd &lt; e.length) {<a name="line.520"></a>
<FONT color="green">521</FONT>                                    final int v = (0x000000ff &amp; e.buffer[eInd]);<a name="line.521"></a>
<FONT color="green">522</FONT>                                    if (inc) apos[0]++;<a name="line.522"></a>
<FONT color="green">523</FONT>                                    return v;<a name="line.523"></a>
<FONT color="green">524</FONT>                            }<a name="line.524"></a>
<FONT color="green">525</FONT>                    }<a name="line.525"></a>
<FONT color="green">526</FONT>                    finally {<a name="line.526"></a>
<FONT color="green">527</FONT>                            lock.readLock().unlock();<a name="line.527"></a>
<FONT color="green">528</FONT>                    }<a name="line.528"></a>
<FONT color="green">529</FONT>                    //end of stream<a name="line.529"></a>
<FONT color="green">530</FONT>                    return -1;<a name="line.530"></a>
<FONT color="green">531</FONT>            }<a name="line.531"></a>
<FONT color="green">532</FONT>            private int read(final byte[] buf, int off, int len) throws IOException {<a name="line.532"></a>
<FONT color="green">533</FONT>                    if (pos.get() == null) throw new IOException("persister already closed");<a name="line.533"></a>
<FONT color="green">534</FONT>    <a name="line.534"></a>
<FONT color="green">535</FONT>                    final long[] apos = pos.get();<a name="line.535"></a>
<FONT color="green">536</FONT>                    final int eInd  = (int)(apos[0] % entrySize);<a name="line.536"></a>
<FONT color="green">537</FONT>                    <a name="line.537"></a>
<FONT color="green">538</FONT>                    lock.readLock().lock();<a name="line.538"></a>
<FONT color="green">539</FONT>                    try {<a name="line.539"></a>
<FONT color="green">540</FONT>                            final TableEntry e = getEntryForRead();<a name="line.540"></a>
<FONT color="green">541</FONT>                            final int count = Math.min(e.length - eInd, len);<a name="line.541"></a>
<FONT color="green">542</FONT>                            if (count &gt; 0) {<a name="line.542"></a>
<FONT color="green">543</FONT>                                    System.arraycopy(e.buffer, eInd, buf, off, count);<a name="line.543"></a>
<FONT color="green">544</FONT>                                    apos[0] += count;<a name="line.544"></a>
<FONT color="green">545</FONT>                                    return count;<a name="line.545"></a>
<FONT color="green">546</FONT>                            }<a name="line.546"></a>
<FONT color="green">547</FONT>                    }<a name="line.547"></a>
<FONT color="green">548</FONT>                    finally {<a name="line.548"></a>
<FONT color="green">549</FONT>                            lock.readLock().unlock();<a name="line.549"></a>
<FONT color="green">550</FONT>                    }<a name="line.550"></a>
<FONT color="green">551</FONT>                    <a name="line.551"></a>
<FONT color="green">552</FONT>                    //end of stream<a name="line.552"></a>
<FONT color="green">553</FONT>                    return -1;<a name="line.553"></a>
<FONT color="green">554</FONT>            }<a name="line.554"></a>
<FONT color="green">555</FONT>    <a name="line.555"></a>
<FONT color="green">556</FONT>            private void write(int b) throws IOException {<a name="line.556"></a>
<FONT color="green">557</FONT>                    if (pos.get() == null) throw new IOException("persister already closed");<a name="line.557"></a>
<FONT color="green">558</FONT>    <a name="line.558"></a>
<FONT color="green">559</FONT>                    final long[] apos = pos.get();<a name="line.559"></a>
<FONT color="green">560</FONT>                    final int eInd  = (int)(apos[0] % entrySize);<a name="line.560"></a>
<FONT color="green">561</FONT>                    <a name="line.561"></a>
<FONT color="green">562</FONT>                    lock.writeLock().lock();<a name="line.562"></a>
<FONT color="green">563</FONT>                    try {<a name="line.563"></a>
<FONT color="green">564</FONT>                            final TableEntry e = getEntryForWrite();<a name="line.564"></a>
<FONT color="green">565</FONT>                            if (eInd &lt; e.buffer.length) {<a name="line.565"></a>
<FONT color="green">566</FONT>                                    e.buffer[eInd]  = (byte)b;<a name="line.566"></a>
<FONT color="green">567</FONT>                                    e.dirty                 = true;<a name="line.567"></a>
<FONT color="green">568</FONT>                                    e.length                = Math.max(e.length, eInd + 1);<a name="line.568"></a>
<FONT color="green">569</FONT>                                    apos[0]++;<a name="line.569"></a>
<FONT color="green">570</FONT>                            }<a name="line.570"></a>
<FONT color="green">571</FONT>                            else {<a name="line.571"></a>
<FONT color="green">572</FONT>                                    //should not happen<a name="line.572"></a>
<FONT color="green">573</FONT>                                    throw new IOException("internal error, write after buffer length: " + eInd + " &gt;= " + e.buffer.length);<a name="line.573"></a>
<FONT color="green">574</FONT>                            }<a name="line.574"></a>
<FONT color="green">575</FONT>                    }<a name="line.575"></a>
<FONT color="green">576</FONT>                    finally {<a name="line.576"></a>
<FONT color="green">577</FONT>                            lock.writeLock().unlock();<a name="line.577"></a>
<FONT color="green">578</FONT>                    }<a name="line.578"></a>
<FONT color="green">579</FONT>            }<a name="line.579"></a>
<FONT color="green">580</FONT>            <a name="line.580"></a>
<FONT color="green">581</FONT>            private int write(byte[] buf, int off, int len) throws IOException {<a name="line.581"></a>
<FONT color="green">582</FONT>                    if (pos.get() == null) throw new IOException("persister already closed");<a name="line.582"></a>
<FONT color="green">583</FONT>    <a name="line.583"></a>
<FONT color="green">584</FONT>                    final long[] apos = pos.get();<a name="line.584"></a>
<FONT color="green">585</FONT>                    final int eInd  = (int)(apos[0] % entrySize);<a name="line.585"></a>
<FONT color="green">586</FONT>                    <a name="line.586"></a>
<FONT color="green">587</FONT>                    lock.writeLock().lock();<a name="line.587"></a>
<FONT color="green">588</FONT>                    try {<a name="line.588"></a>
<FONT color="green">589</FONT>                            final TableEntry e = getEntryForWrite();<a name="line.589"></a>
<FONT color="green">590</FONT>                            final int count = Math.min(e.buffer.length - eInd, len); <a name="line.590"></a>
<FONT color="green">591</FONT>                            if (count &gt; 0) {<a name="line.591"></a>
<FONT color="green">592</FONT>                                    System.arraycopy(buf, off, e.buffer, eInd, count);<a name="line.592"></a>
<FONT color="green">593</FONT>                                    e.dirty         = true;<a name="line.593"></a>
<FONT color="green">594</FONT>                                    e.length        = Math.max(e.length, eInd + count);<a name="line.594"></a>
<FONT color="green">595</FONT>                                    apos[0] += count;<a name="line.595"></a>
<FONT color="green">596</FONT>                                    return count;<a name="line.596"></a>
<FONT color="green">597</FONT>                            }<a name="line.597"></a>
<FONT color="green">598</FONT>                            //should not happen<a name="line.598"></a>
<FONT color="green">599</FONT>                            throw new IOException("internal error, write after buffer length: " + eInd + " &gt;= " + e.buffer.length);<a name="line.599"></a>
<FONT color="green">600</FONT>                    }<a name="line.600"></a>
<FONT color="green">601</FONT>                    finally {<a name="line.601"></a>
<FONT color="green">602</FONT>                            lock.writeLock().unlock();<a name="line.602"></a>
<FONT color="green">603</FONT>                    }<a name="line.603"></a>
<FONT color="green">604</FONT>            }<a name="line.604"></a>
<FONT color="green">605</FONT>    <a name="line.605"></a>
<FONT color="green">606</FONT>            private class BufferedDataInput extends AbstractDataInput {<a name="line.606"></a>
<FONT color="green">607</FONT>                    @Override<a name="line.607"></a>
<FONT color="green">608</FONT>                    protected int peek() throws IOException {<a name="line.608"></a>
<FONT color="green">609</FONT>                            return BufferedRandomAccessPersister.this.read(false);<a name="line.609"></a>
<FONT color="green">610</FONT>                    }<a name="line.610"></a>
<FONT color="green">611</FONT>                    @Override<a name="line.611"></a>
<FONT color="green">612</FONT>                    protected int read() throws IOException {<a name="line.612"></a>
<FONT color="green">613</FONT>                            return BufferedRandomAccessPersister.this.read(true);<a name="line.613"></a>
<FONT color="green">614</FONT>                    }<a name="line.614"></a>
<FONT color="green">615</FONT>                    @Override<a name="line.615"></a>
<FONT color="green">616</FONT>                    protected int read(byte[] b, int off, int len) throws IOException {<a name="line.616"></a>
<FONT color="green">617</FONT>                            return BufferedRandomAccessPersister.this.read(b, off, len);<a name="line.617"></a>
<FONT color="green">618</FONT>                    }<a name="line.618"></a>
<FONT color="green">619</FONT>                    @Override<a name="line.619"></a>
<FONT color="green">620</FONT>                    public int skipBytes(int n) throws IOException {<a name="line.620"></a>
<FONT color="green">621</FONT>                            //TODO this is very inefficient, but ok for now<a name="line.621"></a>
<FONT color="green">622</FONT>                            int count = 0;<a name="line.622"></a>
<FONT color="green">623</FONT>                            while (count &lt; n) {<a name="line.623"></a>
<FONT color="green">624</FONT>                                    final int b = read();<a name="line.624"></a>
<FONT color="green">625</FONT>                                    if (b &lt; 0) return count;<a name="line.625"></a>
<FONT color="green">626</FONT>                                    count++;<a name="line.626"></a>
<FONT color="green">627</FONT>                            }<a name="line.627"></a>
<FONT color="green">628</FONT>                            return count;<a name="line.628"></a>
<FONT color="green">629</FONT>                    }<a name="line.629"></a>
<FONT color="green">630</FONT>            }<a name="line.630"></a>
<FONT color="green">631</FONT>            <a name="line.631"></a>
<FONT color="green">632</FONT>            private class BufferedDataOutput extends AbstractDataOutput {<a name="line.632"></a>
<FONT color="green">633</FONT>                    public void write(int b) throws IOException {<a name="line.633"></a>
<FONT color="green">634</FONT>                            BufferedRandomAccessPersister.this.write(b);<a name="line.634"></a>
<FONT color="green">635</FONT>                    }<a name="line.635"></a>
<FONT color="green">636</FONT>                    public void write(byte[] b, int off, int len) throws IOException {<a name="line.636"></a>
<FONT color="green">637</FONT>                    int n = 0;<a name="line.637"></a>
<FONT color="green">638</FONT>                    do {<a name="line.638"></a>
<FONT color="green">639</FONT>                                    int count = BufferedRandomAccessPersister.this.write(b, off + n, len - n);<a name="line.639"></a>
<FONT color="green">640</FONT>                        if (count &lt; 0)<a name="line.640"></a>
<FONT color="green">641</FONT>                            throw new EOFException();<a name="line.641"></a>
<FONT color="green">642</FONT>                        n += count;<a name="line.642"></a>
<FONT color="green">643</FONT>                    } while (n &lt; len);<a name="line.643"></a>
<FONT color="green">644</FONT>                    }<a name="line.644"></a>
<FONT color="green">645</FONT>            }<a name="line.645"></a>
<FONT color="green">646</FONT>            <a name="line.646"></a>
<FONT color="green">647</FONT>        /**<a name="line.647"></a>
<FONT color="green">648</FONT>         * Copied from {@link HashMap#hash(int)} <a name="line.648"></a>
<FONT color="green">649</FONT>         * (Java 6, or &lt;code&gt;HashMap#newHash(int)&lt;/code&gt; in Java 5), merged with<a name="line.649"></a>
<FONT color="green">650</FONT>         * {@link Long#hashCode()}.<a name="line.650"></a>
<FONT color="green">651</FONT>         * &lt;p&gt;<a name="line.651"></a>
<FONT color="green">652</FONT>         * Applies a supplemental hash function to a given hashCode, which<a name="line.652"></a>
<FONT color="green">653</FONT>         * defends against poor quality hash functions.  This is critical<a name="line.653"></a>
<FONT color="green">654</FONT>         * because HashMap uses power-of-two length hash tables, that<a name="line.654"></a>
<FONT color="green">655</FONT>         * otherwise encounter collisions for hashCodes that do not differ<a name="line.655"></a>
<FONT color="green">656</FONT>         * in lower bits.<a name="line.656"></a>
<FONT color="green">657</FONT>         */<a name="line.657"></a>
<FONT color="green">658</FONT>        private static int hash(long value) {       <a name="line.658"></a>
<FONT color="green">659</FONT>            int h = (int)(value ^ (value &gt;&gt;&gt; 32));<a name="line.659"></a>
<FONT color="green">660</FONT>            // This function ensures that hashCodes that differ only by<a name="line.660"></a>
<FONT color="green">661</FONT>            // constant multiples at each bit position have a bounded<a name="line.661"></a>
<FONT color="green">662</FONT>            // number of collisions (approximately 8 at default load factor).<a name="line.662"></a>
<FONT color="green">663</FONT>            h ^= (h &gt;&gt;&gt; 20) ^ (h &gt;&gt;&gt; 12);<a name="line.663"></a>
<FONT color="green">664</FONT>            return h ^ (h &gt;&gt;&gt; 7) ^ (h &gt;&gt;&gt; 4);<a name="line.664"></a>
<FONT color="green">665</FONT>        }<a name="line.665"></a>
<FONT color="green">666</FONT>    <a name="line.666"></a>
<FONT color="green">667</FONT>    }<a name="line.667"></a>




























































</PRE>
</BODY>
</HTML>
